
 'use strict';
/*! https://github.com/mckoss/namespace/blob/master/namespace.js minor edits by frdl */
/*
try{
 var root = global ||  new Function("return self || this")();
}catch(e){
  var root = global;	
}
*/
var root = {};
//const __NAME__= 'Webfan';
const versionDefault = '3.1.5';
const __NAME__= 'Module';
const __VERSION__ = 'VERSION';
//var pkg = require('./package.json');

exports = module.exports = make(__NAME__, {

}, root, module.version || versionDefault);
exports.setup = make;






function make(name, config, root, version) {
	
	
    return (function(n, config, g, V) {

        var globalNamespace,
			_mMap = new WeakMap(),
			defaultMethods = ['defined', 'extend', 'config', 'isPrimitive', 'module', 'toData'];
		function methodKey(m){
			//return Symbol.for('@@Module.fn@' + m);
			return Symbol.for(m);
		}
		
       var VERSION = ('string'===typeof V && 3 === V.split(/\./).length ) ? V : versionDefault;
		
       function Module(payload) {
		 var THAT = this;	
		 _mMap.set(THAT,payload || {});
		defaultMethods.forEach(function(method,i){

				Object.defineProperty(THAT, method, {
					  get : function(){
						  var p = _mMap.get(THAT);
						  if('undefined'!==typeof p && 'undefined'!==typeof p[method]){
							  return p[method];
						  }
						  return THAT[methodKey(method)];  
					   },    
					  set: function(value) {  
						  var p = _mMap.get(THAT);
						  p[method]=value;
						   _mMap.set(THAT,p);
					  },
					  configurable: true,
					  enumerable: false
				});
		});
		
			
            if (null !== payload 
				&& 'undefined' !== typeof payload 
				&& 'object' === typeof payload 
				&& 'object' === typeof Object.keys(payload)
				&& Object.keys(payload)instanceof Array
				&& true !== payload instanceof Array) {
                    this[methodKey('extend')](payload);
            }
		   
		  
       }
		
        function Make(payload) {
            if (null !== payload 
				&& 'undefined' !== typeof payload
				&& 'object' === typeof payload
				&& 'object' === typeof Object.keys(payload)
				&& Object.keys(payload)instanceof Array
				&& true !== payload instanceof Module
				&& true !== payload instanceof Array) {
                   return new Module(payload);
            } else {
                return payload;
            }
        }
        function numeric(s) {
            if (!s) {
                return 0;
            }
            var a = s.split('.');
            return 10000 * parseInt(a[0]) + 100 * parseInt(a[1]) + parseInt(a[2]);
        }
        if (globalNamespace) {
            if (numeric(VERSION) <= numeric(globalNamespace[__VERSION__])) {
                return;
            }
            Module = globalNamespace.constructor;
        } else {
            
			globalNamespace = new Module();
			g[n] = globalNamespace;
        }
        globalNamespace[__VERSION__] = VERSION;
        function Defined(path) {
            path = path.replace(/-/g, '_');
            var parts = path.split('.'), i;
            var ns = (n === parts[0]) ? global : globalNamespace;
            for (i = 0; i < parts.length; i++) {
                ns = ns[parts[i]];
                if (typeof ns === 'undefined') {
                    return false;
                }
            }
            return typeof ns !== 'undefined';
        }
        function Require(path) {
            path = path.replace(/-/g, '_');
            var parts = path.split('.');
            var ns = globalNamespace, i;
            for (i = 0; i < parts.length; i++) {
                if (ns[parts[i]] === undefined) {
                    ns[parts[i]] = new Module();
                }
                ns = ns[parts[i]];
            }
            return ns;
        }
        var proto = Module.prototype;
        proto[methodKey('defined')] = function(path) {
            return Defined(path);
        }
        ;
        proto[methodKey('toData')] = function(o) {
            return JSON.parse(JSON.stringify(o || this));
        }
        ;
        proto[methodKey('module')] = function(path, closure) {
            var exports = Require(path);
            if (closure) {
                closure(exports, Require);
            }
            return exports;
        }
        ;
        proto[methodKey('extend')] = function(exports) {
            var sym;
            for (sym in exports) {
                if (exports.hasOwnProperty(sym)) {
                    this[sym] = Make(exports[sym]);
                }
            }
        }
        ;
		
        proto[methodKey('config')] = function(config) {
            var f, THAT = this;
             f = (function f(config) {
			  var k;	 
              for (k in config) {
                THAT[methodKey('module')](k, function(p, r) {
                   if('function'===typeof p[methodKey('extend')]){
					   p[methodKey('extend')](config[k]);
				   }
                });
              }
              return f;
            }(config));
        }
        ;
		
        proto[methodKey('isPrimitive')] = function isPrimitive(val) {
            if (typeof val === 'object') {
                return val === null;
            }
            return typeof val !== 'function';
        }
        ;
        g[n] = globalNamespace;
        g[n].config(config);  
		
	return globalNamespace;
 }(name, config, root, version));
}